package edu.upvehu.mummec;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

public class PVFile {
    
    class Palabra {
        String palabra;
        double duracion;

        public Palabra(String palabra, double duracion) {
            this.palabra = palabra;
            this.duracion = duracion;
        }
        
    }
    
    private final List<Palabra> lp=new ArrayList<>();
    private int invalidas=0;

    public PVFile(String direccion) throws MalformedURLException, IOException {
        
        URL url=new URL(direccion);
        BufferedReader br=new BufferedReader(new InputStreamReader(url.openStream()));
        
        String linea;
        while ((linea=br.readLine())!=null){
            linea=linea.trim();
            if (linea.length()==0 || linea.startsWith("#")) continue;
            String campo2=linea.split("\\t")[2];
            String[] campo2Partido=campo2.split("\\|");
            if (campo2Partido.length>=1){
                if (campo2Partido[1].equals("")) continue;
                if (campo2Partido.length==2){
                    invalidas++;
                    continue;
                }
                String[] numeros=campo2Partido[2].split(" ");
                double duracion=Double.parseDouble(numeros[1])-Double.parseDouble(numeros[0]);
                lp.add(new Palabra(campo2Partido[1],duracion));
           }
            
            
        }
          
    }

    double media(){
        double media=0.0;
        for (Palabra p:lp) media+=p.duracion;
        return media/lp.size();
    }
            
     double desviacion(){
        double desviacion=0.0, media=media();
        for (Palabra p:lp) desviacion+=(p.duracion-media)*(p.duracion-media);
        return Math.sqrt(desviacion/(lp.size()-1));
    }
    
     int getNumeroDePalabras(){
         return lp.size()+invalidas;
     }
    
     int getNumeroDePalabrasValidas(){
         return lp.size();
     }
    
}
